package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesAssemblyNosortCfgService;
import cn.estsh.i3plus.ext.mes.api.base.IMesVolvoRackService;
import cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base.BaseMesService;
import cn.estsh.i3plus.ext.mes.apiservice.utils.MesException;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesAssemblyNosortCfg;
import cn.estsh.i3plus.pojo.mes.bean.MesVolvoRack;
import cn.estsh.i3plus.pojo.mes.bean.MesWcEquipment;
import cn.estsh.impp.framework.boot.util.ValidatorBean;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
@Slf4j
public class MesVolvoRackService extends BaseMesService<MesVolvoRack> implements IMesVolvoRackService {

    protected void setPackQueryBean(MesVolvoRack bean, DdlPackBean packBean) {
        DdlPreparedPack.getStringLikerPack(bean.getRackOwner(), "rackOwner", packBean);
        DdlPreparedPack.getNumEqualPack(bean.getRackType(), "rackType", packBean);
    }

    protected void onInsertBean(MesVolvoRack item) {
        // 数据校验
        ValidatorBean.checkNotNull(item.getRackOwner(), "料架所有者");
        ValidatorBean.checkNotNull(item.getRackSeq(), "料架系列号不能为空");
        ValidatorBean.checkNotNull(item.getRackType(), "料架类型不能为空");
        ValidatorBean.checkNotNull(item.getPositionTotal(), "位置总数不能为空");
    }

    protected void onUpdateBean(MesVolvoRack item) {
        // 数据校验
        ValidatorBean.checkNotNull(item.getRackOwner(), "料架所有者");
        ValidatorBean.checkNotNull(item.getRackSeq(), "料架系列号不能为空");
        ValidatorBean.checkNotNull(item.getRackType(), "料架类型不能为空");
        ValidatorBean.checkNotNull(item.getPositionTotal(), "位置总数不能为空");
    }

    @Override
    public void validateImport(List<MesVolvoRack> beanList) {

        for (MesVolvoRack item : beanList) {
            // 数据校验
            ValidatorBean.checkNotNull(item.getRackOwner(), "料架所有者");
            ValidatorBean.checkNotNull(item.getRackSeq(), "料架系列号不能为空");
            ValidatorBean.checkNotNull(item.getRackType(), "料架类型不能为空");
            ValidatorBean.checkNotNull(item.getPositionTotal(), "位置总数不能为空");

        }
    }
}
